Index: palm/trunk/SOURCE/pmc_interface.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface.f90	(revision 1789)
+++ palm/trunk/SOURCE/pmc_interface.f90	(revision 1791)
@@ -2173,23 +2249,544 @@
 
 
+
+ SUBROUTINE pmci_set_array_pointer( name, client_id, nz_cl )
+
+    IMPLICIT NONE
+
+    INTEGER, INTENT(IN)          ::  client_id   !:
+    INTEGER, INTENT(IN)          ::  nz_cl       !:
+    CHARACTER(LEN=*), INTENT(IN) ::  name        !:
+
+#if defined( __parallel )
+    INTEGER(iwp) ::  ierr        !:
+    INTEGER(iwp) ::  istat       !:
+
+    REAL(wp), POINTER, DIMENSION(:,:)   ::  p_2d        !:
+    REAL(wp), POINTER, DIMENSION(:,:)   ::  p_2d_sec    !:
+    REAL(wp), POINTER, DIMENSION(:,:,:) ::  p_3d        !:
+    REAL(wp), POINTER, DIMENSION(:,:,:) ::  p_3d_sec    !:
+
+
+    NULLIFY( p_3d )
+    NULLIFY( p_2d )
+
+!
+!-- List of array names, which can be coupled.
+!-- In case of 3D please change also the second array for the pointer version
+    IF ( TRIM(name) == "u"  )  p_3d => u
+    IF ( TRIM(name) == "v"  )  p_3d => v
+    IF ( TRIM(name) == "w"  )  p_3d => w
+    IF ( TRIM(name) == "e"  )  p_3d => e
+    IF ( TRIM(name) == "pt" )  p_3d => pt
+    IF ( TRIM(name) == "q"  )  p_3d => q
+!
+!-- Next line is just an example for a 2D array (not active for coupling!)
+!-- Please note, that z0 has to be declared as TARGET array in modules.f90
+!    IF ( TRIM(name) == "z0" )    p_2d => z0
+
+#if defined( __nopointer )
+    IF ( ASSOCIATED( p_3d ) )  THEN
+       CALL pmc_s_set_dataarray( client_id, p_3d, nz_cl, nz )
+    ELSEIF ( ASSOCIATED( p_2d ) )  THEN
+       CALL pmc_s_set_dataarray( client_id, p_2d )
+    ELSE
+!
+!--    Give only one message for the root domain
+       IF ( myid == 0  .AND.  cpl_id == 1 )  THEN
+
+          message_string = 'pointer for array "' // TRIM( name ) //            &
+                           '" can''t be associated'
+          CALL message( 'pmci_set_array_pointer', 'PA0117', 3, 2, 0, 6, 0 )
+       ELSE
+!
+!--       Avoid others to continue
+          CALL MPI_BARRIER( comm2d, ierr )
+       ENDIF
+    ENDIF
+#else
+    IF ( TRIM(name) == "u"  )  p_3d_sec => u_2
+    IF ( TRIM(name) == "v"  )  p_3d_sec => v_2
+    IF ( TRIM(name) == "w"  )  p_3d_sec => w_2
+    IF ( TRIM(name) == "e"  )  p_3d_sec => e_2
+    IF ( TRIM(name) == "pt" )  p_3d_sec => pt_2
+    IF ( TRIM(name) == "q"  )  p_3d_sec => q_2
+
+    IF ( ASSOCIATED( p_3d ) )  THEN
+       CALL pmc_s_set_dataarray( client_id, p_3d, nz_cl, nz, &
+                                 array_2 = p_3d_sec )
+    ELSEIF ( ASSOCIATED( p_2d ) )  THEN
+       CALL pmc_s_set_dataarray( client_id, p_2d )
+    ELSE
+!
+!--    Give only one message for the root domain
+       IF ( myid == 0  .AND.  cpl_id == 1 )  THEN
+
+          message_string = 'pointer for array "' // TRIM( name ) //            &
+                           '" can''t be associated'
+          CALL message( 'pmci_set_array_pointer', 'PA0117', 3, 2, 0, 6, 0 )
+       ELSE
+!
+!--       Avoid others to continue
+          CALL MPI_BARRIER( comm2d, ierr )
+       ENDIF
+
+   ENDIF
+#endif
+
+#endif
+ END SUBROUTINE pmci_set_array_pointer
+
+
+
+ SUBROUTINE pmci_create_client_arrays( name, is, ie, js, je, nzc  )
+
+    IMPLICIT NONE
+
+    CHARACTER(LEN=*), INTENT(IN) ::  name    !:
+
+    INTEGER(iwp), INTENT(IN) ::  ie      !:
+    INTEGER(iwp), INTENT(IN) ::  is      !:
+    INTEGER(iwp), INTENT(IN) ::  je      !:
+    INTEGER(iwp), INTENT(IN) ::  js      !:
+    INTEGER(iwp), INTENT(IN) ::  nzc     !:  Note that nzc is cg%nz
+
+#if defined( __parallel )
+    INTEGER(iwp) ::  ierr    !:
+    INTEGER(iwp) ::  istat   !:
+
+    REAL(wp), POINTER,DIMENSION(:,:)   ::  p_2d    !:
+    REAL(wp), POINTER,DIMENSION(:,:,:) ::  p_3d    !:
+
+
+    NULLIFY( p_3d )
+    NULLIFY( p_2d )
+
+!
+!-- List of array names, which can be coupled.
+!-- TO_DO: Antti: what is the meaning of the next line?
+!-- AH: Note that the k-range of the *c arrays is changed from 1:nz to 0:nz+1.
+    IF ( TRIM( name ) == "u" )  THEN
+       IF ( .NOT. ALLOCATED( uc ) )  ALLOCATE( uc(0:nzc+1, js:je, is:ie) )
+       p_3d => uc
+    ELSEIF ( TRIM( name ) == "v" )  THEN
+       IF ( .NOT. ALLOCATED( vc ) )  ALLOCATE( vc(0:nzc+1, js:je, is:ie) )
+       p_3d => vc
+    ELSEIF ( TRIM( name ) == "w" )  THEN
+       IF ( .NOT. ALLOCATED( wc ) )  ALLOCATE( wc(0:nzc+1, js:je, is:ie) )
+       p_3d => wc
+    ELSEIF ( TRIM( name ) == "e" )  THEN
+       IF ( .NOT. ALLOCATED( ec ) )  ALLOCATE( ec(0:nzc+1, js:je, is:ie) )
+       p_3d => ec
+    ELSEIF ( TRIM( name ) == "pt")  THEN
+       IF ( .NOT. ALLOCATED( ptc ) ) ALLOCATE( ptc(0:nzc+1, js:je, is:ie) )
+       p_3d => ptc
+    ELSEIF ( TRIM( name ) == "q")  THEN
+       IF ( .NOT. ALLOCATED( qc ) ) ALLOCATE( qc(0:nzc+1, js:je, is:ie) )
+       p_3d => qc
+    !ELSEIF (trim(name) == "z0") then
+       !IF (.not.allocated(z0c))  allocate(z0c(js:je, is:ie))
+       !p_2d => z0c
+    ENDIF
+
+    IF ( ASSOCIATED( p_3d ) )  THEN
+       CALL pmc_c_set_dataarray( p_3d )
+    ELSEIF ( ASSOCIATED( p_2d ) )  THEN
+       CALL pmc_c_set_dataarray( p_2d )
+    ELSE
+!
+!--    Give only one message for the first client domain
+       IF ( myid == 0  .AND.  cpl_id == 2 )  THEN
+
+          message_string = 'pointer for array "' // TRIM( name ) //            &
+                           '" can''t be associated'
+          CALL message( 'pmci_create_client_arrays', 'PA0170', 3, 2, 0, 6, 0 )
+       ELSE
+!
+!--       Avoid others to continue
+          CALL MPI_BARRIER( comm2d, ierr )
+       ENDIF
+    ENDIF
+
+#endif
+ END SUBROUTINE pmci_create_client_arrays
+
+
+
+ SUBROUTINE pmci_server_initialize
+!-- TO_DO: add general explanations about what this subroutine does
+#if defined( __parallel )
+    IMPLICIT NONE
+
+    INTEGER(iwp) ::  client_id   !:
+    INTEGER(iwp) ::  m           !:
+
+    REAL(wp) ::  waittime    !:
+
+
+    DO  m = 1, SIZE( pmc_server_for_client ) - 1
+       client_id = pmc_server_for_client(m)
+       CALL pmc_s_fillbuffer( client_id, waittime=waittime )
+    ENDDO
+
+#endif
+ END SUBROUTINE pmci_server_initialize
+
+
+
+ SUBROUTINE pmci_client_initialize
+!-- TO_DO: add general explanations about what this subroutine does
+#if defined( __parallel )
+    IMPLICIT NONE
+
+    INTEGER(iwp) ::  i          !:
+    INTEGER(iwp) ::  icl        !:
+    INTEGER(iwp) ::  icr        !:
+    INTEGER(iwp) ::  j          !:
+    INTEGER(iwp) ::  jcn        !:
+    INTEGER(iwp) ::  jcs        !:
+
+    REAL(wp) ::  waittime   !:
+
+!
+!-- Root id is never a client
+    IF ( cpl_id > 1 )  THEN
+
+!
+!--    Client domain boundaries in the server index space
+       icl = coarse_bound(1)
+       icr = coarse_bound(2)
+       jcs = coarse_bound(3)
+       jcn = coarse_bound(4)
+
+!
+!--    Get data from server
+       CALL pmc_c_getbuffer( waittime = waittime )
+
+!
+!--    The interpolation.
+       CALL pmci_interp_tril_all ( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo,   &
+                                   r2yo, r1zo, r2zo, nzb_u_inner, 'u' )
+       CALL pmci_interp_tril_all ( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv,   &
+                                   r2yv, r1zo, r2zo, nzb_v_inner, 'v' )
+       CALL pmci_interp_tril_all ( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo,   &
+                                   r2yo, r1zw, r2zw, nzb_w_inner, 'w' )
+       CALL pmci_interp_tril_all ( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo,   &
+                                   r2yo, r1zo, r2zo, nzb_s_inner, 'e' )
+       CALL pmci_interp_tril_all ( pt, ptc, ico, jco, kco, r1xo, r2xo, r1yo,   &
+                                   r2yo, r1zo, r2zo, nzb_s_inner, 's' )
+       IF ( humidity  .OR.  passive_scalar )  THEN
+          CALL pmci_interp_tril_all ( q, qc, ico, jco, kco, r1xo, r2xo, r1yo,  &
+                                      r2yo, r1zo, r2zo, nzb_s_inner, 's' )
+       ENDIF
+
+       IF ( topography /= 'flat' )  THEN
+!
+!--       Inside buildings set velocities and TKE back to zero.
+!--       Other scalars (pt, q, s, km, kh, p, sa, ...) are ignored at present,
+!--       maybe revise later.
+          DO   i = nxlg, nxrg
+             DO   j = nysg, nyng
+                u(nzb:nzb_u_inner(j,i),j,i)   = 0.0_wp
+                v(nzb:nzb_v_inner(j,i),j,i)   = 0.0_wp
+                w(nzb:nzb_w_inner(j,i),j,i)   = 0.0_wp
+                e(nzb:nzb_s_inner(j,i),j,i)   = 0.0_wp
+                u_p(nzb:nzb_u_inner(j,i),j,i) = 0.0_wp
+                v_p(nzb:nzb_v_inner(j,i),j,i) = 0.0_wp
+                w_p(nzb:nzb_w_inner(j,i),j,i) = 0.0_wp
+                e_p(nzb:nzb_s_inner(j,i),j,i) = 0.0_wp
+             ENDDO
+          ENDDO
+       ENDIF
+    ENDIF
+
+
+ CONTAINS
+
+
+    SUBROUTINE pmci_interp_tril_all( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y,    &
+                                     r1z, r2z, kb, var )
+!
+!--    Interpolation of the internal values for the client-domain initialization
+!--    This subroutine is based on trilinear interpolation.
+!--    Coding based on interp_tril_lr/sn/t
+       IMPLICIT NONE
+
+       CHARACTER(LEN=1), INTENT(IN) :: var  !:
+
+       INTEGER(iwp), DIMENSION(nxlg:nxrg), INTENT(IN)           ::  ic    !:
+       INTEGER(iwp), DIMENSION(nysg:nyng), INTENT(IN)           ::  jc    !:
+       INTEGER(iwp), DIMENSION(nzb:nzt+1), INTENT(IN)           ::  kc    !:
+       INTEGER(iwp), DIMENSION(nysg:nyng,nxlg:nxrg), INTENT(IN) ::  kb    !:
+
+       INTEGER(iwp) ::  i      !:
+       INTEGER(iwp) ::  ib     !:
+       INTEGER(iwp) ::  ie     !:
+       INTEGER(iwp) ::  j      !:
+       INTEGER(iwp) ::  jb     !:
+       INTEGER(iwp) ::  je     !:
+       INTEGER(iwp) ::  k      !:
+       INTEGER(iwp) ::  k1     !:
+       INTEGER(iwp) ::  kbc    !:
+       INTEGER(iwp) ::  l      !:
+       INTEGER(iwp) ::  m      !:
+       INTEGER(iwp) ::  n      !:
+
+       REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), INTENT(INOUT) :: f !:
+       REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN) :: fc    !:
+       REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN) :: r1x   !:
+       REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN) :: r2x   !:
+       REAL(wp), DIMENSION(nysg:nyng), INTENT(IN) :: r1y   !:
+       REAL(wp), DIMENSION(nysg:nyng), INTENT(IN) :: r2y   !:
+       REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN) :: r1z   !:
+       REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN) :: r2z   !:
+
+       REAL(wp) ::  fk         !:
+       REAL(wp) ::  fkj        !:
+       REAL(wp) ::  fkjp       !:
+       REAL(wp) ::  fkp        !:
+       REAL(wp) ::  fkpj       !:
+       REAL(wp) ::  fkpjp      !:
+       REAL(wp) ::  logratio   !:
+       REAL(wp) ::  logzuc1    !:
+       REAL(wp) ::  zuc1       !:
+
+
+       ib = nxl
+       ie = nxr
+       jb = nys
+       je = nyn
+       IF ( nest_bound_l )  THEN
+          ib = nxl - 1
+!
+!--       For u, nxl is a ghost node, but not for the other variables
+          IF ( var == 'u' )  THEN
+             ib = nxl
+          ENDIF
+       ENDIF
+       IF ( nest_bound_s )  THEN
+          jb = nys - 1
+!
+!--       For v, nys is a ghost node, but not for the other variables
+          IF ( var == 'v' )  THEN
+             jb = nys
+          ENDIF
+       ENDIF
+       IF ( nest_bound_r )  THEN
+          ie = nxr + 1
+       ENDIF
+       IF ( nest_bound_n )  THEN
+          je = nyn + 1
+       ENDIF
+
+!
+!--    Trilinear interpolation.
+       DO  i = ib, ie
+          DO  j = jb, je
+             DO  k = kb(j,i), nzt + 1
+                l = ic(i)
+                m = jc(j)
+                n = kc(k)
+                fkj      = r1x(i) * fc(n,m,l)     + r2x(i) * fc(n,m,l+1)
+                fkjp     = r1x(i) * fc(n,m+1,l)   + r2x(i) * fc(n,m+1,l+1)
+                fkpj     = r1x(i) * fc(n+1,m,l)   + r2x(i) * fc(n+1,m,l+1)
+                fkpjp    = r1x(i) * fc(n+1,m+1,l) + r2x(i) * fc(n+1,m+1,l+1)
+                fk       = r1y(j) * fkj  + r2y(j) * fkjp
+                fkp      = r1y(j) * fkpj + r2y(j) * fkpjp
+                f(k,j,i) = r1z(k) * fk   + r2z(k) * fkp
+             ENDDO
+          ENDDO
+       ENDDO
+
+!
+!--    Correct the interpolated values of u and v in near-wall nodes, i.e. in
+!--    the nodes below the coarse-grid nodes with k=1. The corrction is only
+!--    made over horizontal wall surfaces in this phase. For the nest boundary
+!--    conditions, a corresponding correction is made for all vertical walls,
+!--    too.
+       IF ( var == 'u' .OR. var == 'v' )  THEN
+          DO  i = ib, nxr
+             DO  j = jb, nyn
+                kbc = 1
+!
+!--             kbc is the first coarse-grid point above the surface
+                DO  WHILE ( cg%zu(kbc) < zu(kb(j,i)) )
+                   kbc = kbc + 1
+                ENDDO
+                zuc1 = cg%zu(kbc)
+                k1   = kb(j,i) + 1
+                DO  WHILE ( zu(k1) < zuc1 )
+                   k1 = k1 + 1
+                ENDDO
+                logzuc1 = LOG( ( zu(k1) - zu(kb(j,i)) ) / z0(j,i) )
+
+                k = kb(j,i) + 1
+                DO  WHILE ( zu(k) < zuc1 )
+                   logratio = ( LOG( ( zu(k) - zu(kb(j,i)) ) / z0(j,i)) ) / logzuc1
+                   f(k,j,i) = logratio * f(k1,j,i)
+                   k  = k + 1
+                ENDDO
+                f(kb(j,i),j,i) = 0.0_wp
+             ENDDO
+          ENDDO
+
+       ELSEIF ( var == 'w' )  THEN
+
+          DO  i = ib, nxr
+              DO  j = jb, nyn
+                f(kb(j,i),j,i) = 0.0_wp
+             ENDDO
+          ENDDO
+
+       ENDIF
+
+    END SUBROUTINE pmci_interp_tril_all
+
+#endif
+ END SUBROUTINE pmci_client_initialize
+
+
+
+ SUBROUTINE pmci_ensure_nest_mass_conservation
+
+#if defined( __parallel )
+!
+!-- Adjust the volume-flow rate through the top boundary so that the net volume
+!-- flow through all boundaries of the current nest domain becomes zero.
+    IMPLICIT NONE
+
+    INTEGER(iwp) ::  i                          !:
+    INTEGER(iwp) ::  ierr                       !:
+    INTEGER(iwp) ::  j                          !:
+    INTEGER(iwp) ::  k                          !:
+
+    REAL(wp) ::  dxdy                            !:
+    REAL(wp) ::  innor                           !:
+    REAL(wp) ::  w_lt                            !:
+    REAL(wp), DIMENSION(1:3) ::  volume_flow_l   !:
+
+!
+!-- Sum up the volume flow through the left/right boundaries
+    volume_flow(1)   = 0.0_wp
+    volume_flow_l(1) = 0.0_wp
+
+    IF ( nest_bound_l )  THEN
+       i = 0
+       innor = dy
+       DO   j = nys, nyn
+          DO   k = nzb_u_inner(j,i)+1, nzt
+             volume_flow_l(1) = volume_flow_l(1) + innor * u(k,j,i) * dzw(k)
+          ENDDO
+       ENDDO
+    ENDIF
+
+    IF ( nest_bound_r )  THEN
+       i = nx + 1
+       innor = -dy
+       DO   j = nys, nyn
+          DO   k = nzb_u_inner(j,i)+1, nzt
+             volume_flow_l(1) = volume_flow_l(1) + innor * u(k,j,i) * dzw(k)
+          ENDDO
+       ENDDO
+    ENDIF
+
+#if defined( __parallel )
+    IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
+    CALL MPI_ALLREDUCE( volume_flow_l(1), volume_flow(1), 1, MPI_REAL, &
+                        MPI_SUM, comm2d, ierr )
+#else
+    volume_flow(1) = volume_flow_l(1)
+#endif
+
+!
+!-- Sum up the volume flow through the south/north boundaries
+    volume_flow(2)   = 0.0_wp
+    volume_flow_l(2) = 0.0_wp
+
+    IF ( nest_bound_s )  THEN
+       j = 0
+       innor = dx
+       DO   i = nxl, nxr
+          DO   k = nzb_v_inner(j,i)+1, nzt
+             volume_flow_l(2) = volume_flow_l(2) + innor * v(k,j,i) * dzw(k)
+          ENDDO
+       ENDDO
+    ENDIF
+
+    IF ( nest_bound_n )  THEN
+       j = ny + 1
+       innor = -dx
+       DO   i = nxl, nxr
+          DO   k = nzb_v_inner(j,i)+1, nzt
+             volume_flow_l(2) = volume_flow_l(2) + innor * v(k,j,i) * dzw(k)
+          ENDDO
+       ENDDO
+    ENDIF
+
+#if defined( __parallel )
+    IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
+    CALL MPI_ALLREDUCE( volume_flow_l(2), volume_flow(2), 1, MPI_REAL,         &
+                        MPI_SUM, comm2d, ierr )
+#else
+    volume_flow(2) = volume_flow_l(2)
+#endif
+
+!
+!-- Sum up the volume flow through the top boundary
+    volume_flow(3)   = 0.0_wp
+    volume_flow_l(3) = 0.0_wp
+    dxdy = dx * dy
+    k = nzt
+    DO   i = nxl, nxr
+       DO   j = nys, nyn
+          volume_flow_l(3) = volume_flow_l(3) - w(k,j,i) * dxdy
+       ENDDO
+    ENDDO
+
+#if defined( __parallel )
+    IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
+    CALL MPI_ALLREDUCE( volume_flow_l(3), volume_flow(3), 1, MPI_REAL,         &
+                        MPI_SUM, comm2d, ierr )
+#else
+    volume_flow(3) = volume_flow_l(3)
+#endif
+
+!
+!-- Correct the top-boundary value of w
+    w_lt = (volume_flow(1) + volume_flow(2) + volume_flow(3)) / area_t
+    DO   i = nxl, nxr
+       DO   j = nys, nyn
+          DO  k = nzt, nzt + 1
+             w(k,j,i) = w(k,j,i) + w_lt
+          ENDDO
+       ENDDO
+    ENDDO
+
+#endif
+ END SUBROUTINE pmci_ensure_nest_mass_conservation
+
+
+!-- TO_DO: the timestep sycnchronization could be done easier using
+!--        an MPI_ALLREDUCE with MIN over MPI_COMM_WORLD
  SUBROUTINE pmci_server_synchronize
 
 #if defined( __parallel )
 !
-!-- Unify the time steps for each model and synchronize.
-!-- This is based on the assumption that the native time step
-!-- (original dt_3d) of any server is always larger than the smallest 
-!-- native time step of it s clients. 
+!-- Unify the time steps for each model and synchronize. This is based on the
+!-- assumption that the native time step (original dt_3d) of any server is
+!-- always larger than the smallest native time step of it s clients.
     IMPLICIT NONE
-    INTEGER(iwp)           ::  client_id   !:
+
+    INTEGER(iwp) ::  client_id   !:
+    INTEGER(iwp) ::  ierr        !:
+    INTEGER(iwp) ::  m           !:
+
     REAL(wp), DIMENSION(1) ::  dtc         !:
     REAL(wp), DIMENSION(1) ::  dtl         !:
-    INTEGER(iwp)           ::  ierr        !:
-    INTEGER(iwp)           ::  m           !:    
-
-!
-!-- First find the smallest native time step of all the clients of the current server.
+
+!
+!-- First find the smallest native time step of all the clients of the current
+!-- server.
     dtl(1) = 999999.9_wp
-    DO  m = 1, SIZE( PMC_Server_for_Client ) - 1
+    DO  m = 1, SIZE( PMC_Server_for_Client )-1
        client_id = PMC_Server_for_Client(m)
        IF ( myid == 0 )  THEN
@@ -2201,9 +2798,9 @@
 
 !
-!-- Broadcast the unified time step to all server processes.
+!-- Broadcast the unified time step to all server processes
     CALL MPI_BCAST( dt_3d, 1, MPI_REAL, 0, comm2d, ierr )
 
 !
-!-- Send the new time step to all the clients of the current server.
+!-- Send the new time step to all the clients of the current server
     DO  m = 1, SIZE( PMC_Server_for_Client ) - 1
        client_id = PMC_Server_for_Client(m)
@@ -2222,17 +2819,18 @@
 #if defined( __parallel )
 !
-!-- Unify the time steps for each model and synchronize.
-!-- This is based on the assumption that the native time step
-!-- (original dt_3d) of any server is always larger than the smallest 
-!-- native time step of it s clients. 
+!-- Unify the time steps for each model and synchronize. This is based on the
+!-- assumption that the native time step (original dt_3d) of any server is
+!-- always larger than the smallest native time step of it s clients.
 
     IMPLICIT NONE
+
+    INTEGER(iwp) ::  ierr   !:
+
     REAL(wp), DIMENSION(1) ::  dtl    !:
     REAL(wp), DIMENSION(1) ::  dts    !:
-    INTEGER(iwp)           ::  ierr   !:
     
 
     dtl(1) = dt_3d
-    IF ( cpl_id > 1 )  THEN   !  Root id is never a client
+    IF ( cpl_id > 1 )  THEN
        IF ( myid==0 )  THEN
           CALL pmc_send_to_server( dtl, SIZE( dtl ), 0, 101, ierr )
@@ -2242,5 +2840,5 @@
 
 !
-!--    Broadcast the unified time step to all server processes.
+!--    Broadcast the unified time step to all server processes
        CALL MPI_BCAST( dt_3d, 1, MPI_REAL, 0, comm2d, ierr )
     ENDIF
@@ -2255,5 +2853,6 @@
     IMPLICIT NONE
 
-    INTEGER(iwp),INTENT(IN) ::  swaplevel  !: swaplevel (1 or 2) of PALM's timestep
+    INTEGER(iwp),INTENT(IN) ::  swaplevel  !: swaplevel (1 or 2) of PALM's
+                                           !: timestep
 
     INTEGER(iwp)            ::  client_id  !:
@@ -2278,18 +2877,20 @@
 
 #if defined( __parallel )
-    INTEGER(iwp)            ::  client_id   !:
-    INTEGER(iwp)            ::  i           !:
-    INTEGER(iwp)            ::  j           !:
-    INTEGER(iwp)            ::  ierr        !:
-    INTEGER(iwp)            ::  m           !:
-    REAL(wp)                ::  waittime    !:
-    REAL(wp), DIMENSION(1)  ::  dtc         !:
-    REAL(wp), DIMENSION(1)  ::  dtl         !:
-
-!
-!-- First find the smallest native time step of all the clients of the current server.
+    INTEGER(iwp) ::  client_id   !:
+    INTEGER(iwp) ::  i           !:
+    INTEGER(iwp) ::  j           !:
+    INTEGER(iwp) ::  ierr        !:
+    INTEGER(iwp) ::  m           !:
+
+    REAL(wp)               ::  waittime    !:
+    REAL(wp), DIMENSION(1) ::  dtc         !:
+    REAL(wp), DIMENSION(1) ::  dtl         !:
+
+!
+!-- First find the smallest native time step of all the clients of the current
+!-- server.
     dtl(1) = 999999.9_wp
-    DO  m = 1, SIZE( PMC_Server_for_Client ) - 1
-       client_id = PMC_Server_for_Client(m)
+    DO  m = 1, SIZE( pmc_server_for_client )-1
+       client_id = pmc_server_for_client(m)
        IF ( myid==0 )  THEN
           CALL pmc_recv_from_client( client_id, dtc, SIZE( dtc ), 0, 101, ierr )
@@ -2300,36 +2901,39 @@
 
 !
-!-- Broadcast the unified time step to all server processes.
+!-- Broadcast the unified time step to all server processes
     CALL MPI_BCAST( dt_3d, 1, MPI_REAL, 0, comm2d, ierr )
 
-    DO  m = 1, SIZE( PMC_Server_for_Client ) - 1
+    DO  m = 1, SIZE( PMC_Server_for_Client )-1
        client_id = PMC_Server_for_Client(m)
-       CALL cpu_log( log_point_s(70), 'PMC model sync', 'start' )
-
-!
-!--    Send the new time step to all the clients of the current server.
-       IF ( myid == 0 ) THEN
+       CALL cpu_log( log_point_s(70), 'pmc sync', 'start' )
+
+!
+!--    Send the new time step to all the clients of the current server
+       IF ( myid == 0 )  THEN
           CALL pmc_send_to_client( client_id, dtl, SIZE( dtl ), 0, 102, ierr )
        ENDIF
-       CALL cpu_log( log_point_s(70), 'PMC model sync', 'stop' )
+       CALL cpu_log( log_point_s(70), 'pmc sync', 'stop' )
        
        IF ( direction == server_to_client )  THEN
-          CALL cpu_log( log_point_s(71), 'PMC Server Send', 'start' )
+          CALL cpu_log( log_point_s(71), 'pmc server send', 'start' )
           CALL pmc_s_fillbuffer( client_id, waittime=waittime )
-          CALL cpu_log( log_point_s(71), 'PMC Server Send', 'stop' )
-       ELSE   !  Communication from client to server.
-          CALL cpu_log( log_point_s(72), 'PMC Server Recv', 'start' )
+          CALL cpu_log( log_point_s(71), 'pmc server send', 'stop' )
+       ELSE
+!
+!--       Communication from client to server
+          CALL cpu_log( log_point_s(72), 'pmc server recv', 'start' )
           client_id = pmc_server_for_client(m)
           CALL pmc_s_getdata_from_buffer( client_id )
-          CALL cpu_log( log_point_s(72), 'PMC Server Recv', 'stop' )        
-
-!
-!--       The anterpolated data is now available in u etc.
+          CALL cpu_log( log_point_s(72), 'pmc server recv', 'stop' )
+
+!
+!--       The anterpolated data is now available in u etc
           IF ( topography /= 'flat' )  THEN
 
 !
 !--          Inside buildings/topography reset velocities and TKE back to zero.
-!--          Other scalars (pt, q, s, km, kh, p, sa, ...) are ignored at present,
-!--          maybe revise later.
+!--          TO_DO: at least temperature should be included here immediately
+!--          Other scalars (pt, q, s, km, kh, p, sa, ...) are ignored at
+!--          present, maybe revise later.
              DO   i = nxlg, nxrg
                 DO   j = nysg, nyng
@@ -2337,5 +2941,5 @@
                    v(nzb:nzb_v_inner(j,i),j,i) = 0.0_wp
                    w(nzb:nzb_w_inner(j,i),j,i) = 0.0_wp
-                   e(nzb:nzb_w_inner(j,i),j,i) = 0.0_wp
+                   e(nzb:nzb_s_inner(j,i),j,i) = 0.0_wp
                 ENDDO
              ENDDO
@@ -2356,18 +2960,19 @@
 
 #if defined( __parallel )
-    INTEGER(iwp)             ::  ierr        !:
-    INTEGER(iwp)             ::  icl         !:
-    INTEGER(iwp)             ::  icr         !:
-    INTEGER(iwp)             ::  jcs         !:
-    INTEGER(iwp)             ::  jcn         !:
+    INTEGER(iwp) ::  ierr        !:
+    INTEGER(iwp) ::  icl         !:
+    INTEGER(iwp) ::  icr         !:
+    INTEGER(iwp) ::  jcs         !:
+    INTEGER(iwp) ::  jcn         !:
     
-    REAL(wp), DIMENSION(1)   ::  dtl         !:
-    REAL(wp), DIMENSION(1)   ::  dts         !:
-    REAL(wp)                 ::  waittime    !:
+    REAL(wp) ::  waittime    !:
+
+    REAL(wp), DIMENSION(1) ::  dtl         !:
+    REAL(wp), DIMENSION(1) ::  dts         !:
 
 
     dtl = dt_3d
-    IF ( cpl_id > 1 )  THEN   !  Root id is never a client      
-       CALL cpu_log( log_point_s(70), 'PMC model sync', 'start' )
+    IF ( cpl_id > 1 )  THEN
+       CALL cpu_log( log_point_s(70), 'pmc sync', 'start' )
        IF ( myid==0 )  THEN
           CALL pmc_send_to_server( dtl, SIZE( dtl ), 0, 101, ierr )
@@ -2379,5 +2984,5 @@
 !--    Broadcast the unified time step to all server processes.
        CALL MPI_BCAST( dt_3d, 1, MPI_REAL, 0, comm2d, ierr )
-       CALL cpu_log( log_point_s(70), 'PMC model sync', 'stop' )
+       CALL cpu_log( log_point_s(70), 'pmc sync', 'stop' )
 
 !
@@ -2389,17 +2994,20 @@
 
        IF ( direction == server_to_client )  THEN
-          CALL cpu_log( log_point_s(73), 'PMC Client Recv', 'start' )
+
+          CALL cpu_log( log_point_s(73), 'pmc client recv', 'start' )
           CALL pmc_c_getbuffer( WaitTime = WaitTime )
-          CALL cpu_log( log_point_s(73), 'PMC Client Recv', 'stop' )
+          CALL cpu_log( log_point_s(73), 'pmc client recv', 'stop' )
 
           CALL pmci_interpolation
 
-       ELSE    !  IF ( direction == server_to_client )
-
+       ELSE
+!
+!--       direction == server_to_client
           CALL pmci_anterpolation
 
-          CALL cpu_log( log_point_s(74), 'PMC Client Send', 'start' )
+          CALL cpu_log( log_point_s(74), 'pmc client send', 'start' )
           CALL pmc_c_putbuffer( WaitTime = WaitTime )
-          CALL cpu_log( log_point_s(74), 'PMC Client Send', 'stop' )
+          CALL cpu_log( log_point_s(74), 'pmc client send', 'stop' )
+
        ENDIF
     ENDIF
